=== debian/rules ===
#! /usr/bin/make -f

export DEB_CPPFLAGS_MAINT_APPEND := -Wconversion

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

ARCH = $(shell dpkg-architecture -qDEB_TARGET_MULTIARCH)

CMAKE_FLAGS = \
	-DLIB_SUFFIX=/$(ARCH) \
	-DBUILD_TESTING:BOOL=ON \
	-DLIBMINC_BUILD_EZMINC_EXAMPLES:BOOL=ON \
	-DLIBMINC_BUILD_SHARED_LIBS:BOOL=ON \
	-DLIBMINC_MINC1_SUPPORT:BOOL=ON

%:
	dh $@

override_dh_auto_configure:
	rm -f cmake-modules/*HDF5*
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_install:
	dh_install -plibminc2-4.0.0 --autodest debian/tmp/usr/lib/*/lib*.so.*
	dh_install -plibminc-dev --autodest debian/tmp/usr/lib/*/lib*.so
	dh_install -plibminc-dev debian/tmp/usr/lib/*/*.cmake /usr/lib/$(ARCH)/cmake/LIBMINC
	dh_install -plibminc-dev --autodest debian/tmp/usr/include

override_dh_auto_test:
	dh_auto_test --no-parallel
